/*************************************************************************************************\
Author:         Maros Grajcar
Company:        Husky Energy
Description:    Controller Unit Test for FM_TruckTripRenewConfirmCtrl.cls
History:        grajcm - 06.21.2018 - Created
**************************************************************************************************/

//done + improve
@isTest
private class FM_TruckTripRenewConfirmCtrlTest {
	//done
	@isTest static void controllerFalseInitializationParameterTest () {
        Test.startTest();
		System.assert(!ApexPages.hasMessages());
		ApexPages.StandardController stdCtrl = new ApexPages.StandardController(new FM_Truck_Trip__c()); //inicializacia
		FM_TruckTripRenewConfirmCtrl controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl); //volanie konstruktora bez parametra 
		ApexPages.currentPage().getParameters().put('id', [SELECT Id 
															FROM FM_Truck_Trip__c 
															WHERE Truck_Trip_Status__c !=: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED][0].Id); //urcenie hodnoty parametra
		controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl); // volanie konstruktora so zlym parametrom
		System.assert(String.valueOf(ApexPages.getMessages()).contains(FM_TruckTrip_Utilities.ERROR_WRONG_STATUS));
		System.assert(String.valueOf(ApexPages.getMessages()).contains(FM_TruckTrip_Utilities.ERROR_WRONG_ID_PARAM));
        Test.stopTest();	
	}
    //done
    @isTest static void controllerTTRenewInitializationParameterTest() {
        id oldTruckTripId = [SELECT Id 
                            FROM FM_Truck_Trip__c 
                            WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED 
                                AND Shift_Day__c = 'Tomorrow'][0].Id;


        // User s FM dispecer PS
        User usr = HOG_TestDataFactory.createUser('Lucifer', 'Morningstar', 'TheDevil');
        usr = HOG_TestDataFactory.assignPermissionSet(usr, 'HOG_FM_Dispatcher');

        System.runAs(usr) {
            Test.startTest();
            ApexPages.currentPage().getParameters().put('id', oldTruckTripId); 
            ApexPages.StandardController stdCtrl = new ApexPages.StandardController(new FM_Truck_Trip__c());
            FM_TruckTripRenewConfirmCtrl controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl); 

            System.assertEquals(FM_TruckTrip_Utilities.uncancelModes, controller.uncancelModeOptions);
            System.assertEquals(FM_TruckTrip_Utilities.MODE_TITLE, controller.modeTitle);
            System.assertEquals(FM_LoadConfirmation_Utilities.NOTE_STUCKTRUCK_UNIT_FROM_CONFIRMATION, controller.getStuckTruckUnitNoteText());
            System.assertEquals(FM_TruckTrip_Utilities.LABEL_OLD_TRUCKTRIP, controller.getOldTruckTripLabel());
                       
            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_RENEW; // pickup button = picklist
         
            Integer beforeRenewButton = [SELECT Count()
                                        FROM FM_Truck_Trip__c];         

            controller.handleModeChange();
            controller.truckTrip.Truck_Trip_Status__c = FM_TruckTrip_Utilities.STATUS_BOOKED;
            PageReference returnedReference = controller.renew();    
            System.debug('APEX !!!!!!!!!!!!!!!!!!!!!!!!!!!!! ' + ApexPages.getMessages());
            //System.assert(!ApexPages.hasMessages());

            Integer afterRenewButton = [SELECT Count()
                                        FROM FM_Truck_Trip__c];          

             
            List<FM_Truck_Trip__c> queryForSelection = [SELECT Id
                                                            , Truck_Trip_Status__c
                                                            , Uncancelled_Truck_Trip__r.Id
                                                        FROM FM_Truck_Trip__c
                                                        WHERE Shift_Day__c = 'Tomorrow'
                                                        ORDER BY CreatedDate];


            String oldTruckTripDifferentStatus = queryForSelection[0].Truck_Trip_Status__c;
            String oldTruckTripRenewToNewTruckTripId = queryForSelection[1].Id;
            System.assertEquals(false, controller.initError);
            // getUrl poriesi to co ma bt rovnake bo bez toho sice vypise to iste ale instancie su ine v objekte
            System.assertEquals(returnedReference.getUrl(), new ApexPages.StandardController(controller.truckTrip).view().getUrl()); 
            System.assertEquals(controller.oldTruckTrip.Uncancelled_Truck_Trip__c, oldTruckTripRenewToNewTruckTripId);           
            System.assertEquals(FM_TruckTrip_Utilities.STATUS_UNCANCELLED, oldTruckTripDifferentStatus);
            System.assertEquals(FM_TruckTrip_Utilities.STATUS_BOOKED, controller.truckTrip.Truck_Trip_Status__c);
            System.assertNotEquals(beforeRenewButton, afterRenewButton);
            System.assert(!ApexPages.hasMessages());
            Test.stopTest();
        }
    } 
    //done
    @isTest static void controllerTTConfirmTest() {

        id oldTruckTripId = [SELECT Id 
                            FROM FM_Truck_Trip__c 
                            WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED
                                AND Shift_Day__c = 'Today'][0].Id;

        User usr = HOG_TestDataFactory.createUser('Lucifer', 'Morningstar', 'TheDevil');
        usr = HOG_TestDataFactory.assignPermissionSet(usr, 'HOG_FM_Dispatcher');

        System.runAs(usr) {
            Test.startTest();                                
            ApexPages.currentPage().getParameters().put('id', oldTruckTripId); //urcenie hodnoty parametra
            ApexPages.StandardController stdCtrl = new ApexPages.StandardController(new FM_Truck_Trip__c()); //inicializacia
            FM_TruckTripRenewConfirmCtrl controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl); //volanie konstruktora bez parametra

            Integer beforeConfirmButton = [SELECT Count()
                                        FROM FM_Truck_Trip__c];

            Facility__c facilityConfirm = [SELECT Id
                                            FROM Facility__c 
                                            LIMIT 1];

            Carrier_Unit__c unitConfirm = [SELECT Id
                                            FROM Carrier_Unit__c
                                            LIMIT 1];

            
            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM;

            controller.handleModeChange();
            controller.loadConfirmation.Ticket_Number__c = 'Test1234';
            controller.loadConfirmation.Volume__c = 30;
            controller.truckTrip.Unit__c = unitConfirm.Id;
            controller.loadConfirmation.Destination_Facility__c = facilityConfirm.Id;
            controller.loadConfirmation.Scale_Ticket_Number__c = 'Test4321';
            controller.truckTrip.Truck_Trip_Status__c = FM_TruckTrip_Utilities.STATUS_COMPLETED;
            PageReference returnedReference = controller.confirm();
            System.assert(!ApexPages.hasMessages());
            System.assertEquals(FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM, controller.selectedMode);

            Integer afterConfirmButton = [SELECT Count()
                                          FROM FM_Truck_Trip__c];

            List<FM_Truck_Trip__c> oldTruckTrip = [SELECT Id
                                                        , Truck_Trip_Status__c
                                                        , Uncancelled_Truck_Trip__c
                                                    FROM FM_Truck_Trip__c
                                                    WHERE Id =: controller.oldTruckTrip.Id];

            List<FM_Truck_Trip__c> newTruckTrip = [SELECT Id
                                                         , Truck_Trip_Status__c
                                                    FROM FM_Truck_Trip__c
                                                    WHERE Id =: controller.truckTrip.Id];


            System.assertNotEquals(beforeConfirmButton, afterConfirmButton);
            System.assertNotEquals(null, controller.truckTrip);

            String oldTruckTripDifferentStatus = oldTruckTrip[0].Truck_Trip_Status__c;
            String oldTruckTripConfirmToTruckTripId = newTruckTrip[0].Id;
            System.assertEquals(false, controller.initError);
            System.assertEquals(returnedReference.getUrl(), new ApexPages.StandardController(controller.truckTrip).view().getUrl()); 
            System.assertEquals(controller.oldTruckTrip.Uncancelled_Truck_Trip__c, oldTruckTripConfirmToTruckTripId);
            System.assertEquals(FM_TruckTrip_Utilities.STATUS_UNCANCELLED, oldTruckTripDifferentStatus);
            System.assertEquals(FM_TruckTrip_Utilities.STATUS_COMPLETED, controller.truckTrip.Truck_Trip_Status__c);
            System.assertNotEquals(null, controller.loadConfirmation.Destination_Facility__c);
            System.assertNotEquals(null, controller.loadConfirmation.Ticket_Number__c);
            System.assertNotEquals(null, controller.loadConfirmation.Volume__c);
            System.assert(!ApexPages.hasMessages());
            Test.stopTest();
        }
    }
    // done
    @isTest static void ButtonsNoDataTest() {

        User usr = HOG_TestDataFactory.createUser('Lucifer', 'Morningstar', 'TheDevil');
        usr = HOG_TestDataFactory.assignPermissionSet(usr, 'HOG_FM_Dispatcher');

        System.runAs(usr) {
            Test.startTest();                                
            ApexPages.currentPage().getParameters().put('id', null); //urcenie hodnoty parametra
            ApexPages.StandardController stdCtrl = new ApexPages.StandardController(new FM_Truck_Trip__c()); //inicializacia
            FM_TruckTripRenewConfirmCtrl controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl); //volanie konstruktora bez parametra

            controller.renew();
            System.assertEquals(null, controller.renew());
            controller.confirm();
            System.assertEquals(null, controller.confirm());
            PageReference returnedReferenceHome = controller.cancel(); 
            System.assertEquals(returnedReferenceHome.getUrl(), new PageReference('/').getUrl()); 
            System.assertEquals(null, controller.loadConfirmation.Truck_Trip__r);
            System.assert(ApexPages.hasMessages());
            Test.stopTest();
        }
    }
    // done
    @isTest static void CancelConfirmButtonWithDataTest() {
        id oldTruckTripId = [SELECT Id 
                            FROM FM_Truck_Trip__c 
                            WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED
                                AND Shift_Day__c = 'Today'][0].Id;

        User usr = HOG_TestDataFactory.createUser('Lucifer', 'Morningstar', 'TheDevil');
        usr = HOG_TestDataFactory.assignPermissionSet(usr, 'HOG_FM_Dispatcher');

        System.runAs(usr) {
            Test.startTest();                                
            ApexPages.currentPage().getParameters().put('id', oldTruckTripId); //urcenie hodnoty parametra
            ApexPages.StandardController stdCtrl = new ApexPages.StandardController(new FM_Truck_Trip__c()); //inicializacia
            FM_TruckTripRenewConfirmCtrl controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl);    
            
            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM;

            // shows oldTruckTrip card, original TT
            controller.handleModeChange();
            controller.truckTrip.Truck_Trip_Status__c = FM_TruckTrip_Utilities.STATUS_DISPATCHED;
            PageReference returnedReference = controller.cancel();
            System.assertEquals(returnedReference.getUrl(), new ApexPages.StandardController(controller.oldTruckTrip).view().getUrl());
            System.assert(!ApexPages.hasMessages());

            // still has oldTruckTripId
            Id forAssert = controller.oldTruckTrip.Id;
            controller.oldTruckTrip = null;
            PageReference returnedReference1 = controller.cancel();
            System.assertEquals(returnedReference1.getUrl(), new ApexPages.StandardController(new FM_Truck_Trip__c(Id = forAssert)).view().getUrl());
            System.assert(!ApexPages.hasMessages());
            Test.stopTest();
        }
    }
    // done 
    @isTest static void validationOnUnitChangeTest() {
        id oldTruckTripId = [SELECT Id 
                            FROM FM_Truck_Trip__c 
                            WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED
                                AND Shift_Day__c = 'Today'][0].Id;

        User usr = HOG_TestDataFactory.createUser('Lucifer', 'Morningstar', 'TheDevil');
        usr = HOG_TestDataFactory.assignPermissionSet(usr, 'HOG_FM_Dispatcher');

        System.runAs(usr) {
            Test.startTest();                                
            ApexPages.currentPage().getParameters().put('id', oldTruckTripId); //urcenie hodnoty parametra
            ApexPages.StandardController stdCtrl = new ApexPages.StandardController(new FM_Truck_Trip__c()); //inicializacia
            FM_TruckTripRenewConfirmCtrl controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl); //volanie konstruktora bez parametra

            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM;
            
            Id oldCarrierUnit = [SELECT Id
                                FROM Carrier_Unit__c][0].Id;

            Id newCarrierUnit= [SELECT Id
                                FROM Carrier_Unit__c][1].Id;

            Facility__c facilityConfirm = [SELECT Id
                                            FROM Facility__c 
                                            LIMIT 1];
            List<Facility__c> facilityForError = [SELECT Id
                                                    FROM Facility__c];
            

            controller.handleModeChange();  
            // unit changed
            controller.loadConfirmation.Truck_Trip__r.Unit__c = oldCarrierUnit;
            controller.loadConfirmation.Ticket_Number__c = 'Test1234';
            controller.loadConfirmation.Volume__c = 30;
            controller.truckTrip.Unit__c = oldCarrierUnit;
            controller.loadConfirmation.Destination_Facility__c = facilityConfirm.Id;
            controller.loadConfirmation.Scale_Ticket_Number__c = 'Test4321';
            controller.truckTrip.Truck_Trip_Status__c = FM_TruckTrip_Utilities.STATUS_DISPATCHED;
            controller.oldUnit = newCarrierUnit;                          
            System.assert(controller.getUnitChanged());
            controller.handleUnitChange();
            System.assert(!ApexPages.hasMessages());
            controller.confirm(); 

            // unit unchanged one action handleUnitChange
            controller.loadConfirmation.Truck_Trip__r.Unit__c = oldCarrierUnit;
            controller.oldUnit = oldCarrierUnit; 
            //controller.loadConfirmation.Truck_Trip__r.Unit_Change_Reason__c = '';
            controller.handleUnitChange();
            System.assert(!controller.getUnitChanged()); 
            controller.confirm();

            // unit unchanged another action getUnitChanged
            controller.loadConfirmation.Truck_Trip__r.Unit__c = oldCarrierUnit;
            controller.oldUnit = oldCarrierUnit;
            controller.getUnitChanged();
            System.assert(!controller.getUnitChanged());
            controller.confirm();

            //unit changed reason Other
            controller.loadConfirmation.Truck_Trip__r.Unit__c = oldCarrierUnit;
            controller.oldUnit = newCarrierUnit;
            controller.getUnitChanged();
            System.assert(controller.getUnitChanged());
            controller.loadConfirmation.Truck_Trip__r.Unit_Change_Reason__c = 'Other';
            controller.handleUnitChangeReason();

            controller.confirm();

            // unit changed NO reason
            controller.loadConfirmation.Truck_Trip__r.Unit__c = oldCarrierUnit;
            controller.oldUnit = newCarrierUnit;
            controller.getUnitChanged();
            System.assert(controller.getUnitChanged());
            controller.loadConfirmation.Truck_Trip__r.Unit_Change_Reason__c = null;
            controller.confirm();      
            Test.stopTest();
        }
    }
    //done
    @isTest static void stuckTruckConfirmTest() {
        id oldTruckTripId = [SELECT Id 
                            FROM FM_Truck_Trip__c 
                            WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED
                                AND Shift_Day__c = 'Today'][0].Id;

        User usr = HOG_TestDataFactory.createUser('Lucifer', 'Morningstar', 'TheDevil');
        usr = HOG_TestDataFactory.assignPermissionSet(usr, 'HOG_FM_Dispatcher');

        System.runAs(usr) {
            Test.startTest();                                
            ApexPages.currentPage().getParameters().put('id', oldTruckTripId); //urcenie hodnoty parametra
            ApexPages.StandardController stdCtrl = new ApexPages.StandardController(new FM_Truck_Trip__c()); //inicializacia
            FM_TruckTripRenewConfirmCtrl controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl); //volanie konstruktora bez parametra

            Facility__c facilityConfirm = [SELECT Id
                                            FROM Facility__c 
                                            LIMIT 1];

            Carrier_Unit__c unitConfirm = [SELECT Id
                                            FROM Carrier_Unit__c
                                            LIMIT 1];

            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM; 

            controller.handleModeChange();
            controller.truckTrip.Truck_Trip_Status__c = FM_TruckTrip_Utilities.STATUS_DISPATCHED;
            controller.loadConfirmation.Ticket_Number__c = 'Test1234';
            controller.loadConfirmation.Volume__c = 30;
            controller.truckTrip.Unit__c = unitConfirm.Id;
            controller.loadConfirmation.Destination_Facility__c = facilityConfirm.Id;
            controller.loadConfirmation.Scale_Ticket_Number__c = 'Test4321';
            controller.truckTrip.Truck_Trip_Status__c = FM_TruckTrip_Utilities.STATUS_DISPATCHED;
            System.assert(!ApexPages.hasMessages());
            controller.isStuckTruck = true; 

            Id oldCarrierUnit = [SELECT Id
                                    FROM Carrier_Unit__c][0].Id;
            Id newCarrierUnit = [SELECT Id
                                    FROM Carrier_Unit__c][1].Id;

            Id newTowingCompany = [SELECT Id
                                    FROM Towing_Company__c][0].Id;


            controller.stuckTruck.Carrier_Unit__c = newCarrierUnit;
            controller.stuckTruck.Towing_Company_Lookup__c = newTowingCompany;
            controller.stuckTruck.Stuck_From__c = Datetime.now();
            controller.stuckTruck.Stuck_To__c = Datetime.now()+1;          
            controller.confirm();
            System.assertNotEquals(null, controller.stuckTruck.Towing_Company_Lookup__c);
            System.assertNotEquals(null, controller.stuckTruck.Carrier_Unit__c);
            System.assertNotEquals(null, controller.stuckTruck.Stuck_From__c);
            System.assertNotEquals(null, controller.stuckTruck.Stuck_To__c);
            System.assertNotEquals(null, controller.stuckTruck.Towing_Company_Lookup__c);
            System.assert(!ApexPages.hasMessages());
            Test.stopTest();
        }
    }
    // done
    @isTest static void truckTripAsExternalTest() {
        id oldTruckTripId = [SELECT Id 
                            FROM FM_Truck_Trip__c 
                            WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED
                                AND Shift_Day__c = 'Today'][0].Id;

        User usr = HOG_TestDataFactory.createUser('Lucifer', 'Morningstar', 'TheDevil');
        usr = HOG_TestDataFactory.assignPermissionSet(usr, 'HOG_FM_Dispatcher_Vendor');

        System.runAs(usr) {
            Test.startTest();                                
            ApexPages.currentPage().getParameters().put('id', oldTruckTripId); //urcenie hodnoty parametra
            ApexPages.StandardController stdCtrl = new ApexPages.StandardController(new FM_Truck_Trip__c()); //inicializacia
            FM_TruckTripRenewConfirmCtrl controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl); //volanie konstruktora bez parametra

            Facility__c facilityConfirm = [SELECT Id
                                            FROM Facility__c 
                                            LIMIT 1];

            Carrier_Unit__c unitConfirm = [SELECT Id
                                            FROM Carrier_Unit__c
                                            LIMIT 1];

            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM; 

            controller.handleModeChange();
            controller.truckTrip.Truck_Trip_Status__c = FM_TruckTrip_Utilities.STATUS_DISPATCHED;
            controller.loadConfirmation.Ticket_Number__c = 'Test1234';
            controller.loadConfirmation.Volume__c = 30;
            controller.truckTrip.Unit__c = unitConfirm.Id;
            controller.loadConfirmation.Destination_Facility__c = facilityConfirm.Id;
            controller.loadConfirmation.Scale_Ticket_Number__c = 'Test4321';
            controller.truckTrip.Truck_Trip_Status__c = FM_TruckTrip_Utilities.STATUS_DISPATCHED;
            controller.confirm();
            System.assertNotEquals(null, controller.loadConfirmation.Destination_Facility__c);
            System.assertNotEquals(null, controller.loadConfirmation.Ticket_Number__c);
            System.assertNotEquals(null, controller.loadConfirmation.Volume__c);
            System.assert(!ApexPages.hasMessages()); 

            Id oldCarrierUnit = [SELECT Id
                                    FROM Carrier_Unit__c][0].Id;
            Id newCarrierUnit = [SELECT Id
                                    FROM Carrier_Unit__c][1].Id;

            Id newTowingCompany = [SELECT Id
                                    FROM Towing_Company__c][0].Id;
            Test.stopTest();
        }
    }
    // done
   @isTest static void stuckTruckTripAsExternalTest() {
        id oldTruckTripId = [SELECT Id 
                            FROM FM_Truck_Trip__c 
                            WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED
                                AND Shift_Day__c = 'Today'][0].Id;

        User usr = HOG_TestDataFactory.createUser('Lucifer', 'Morningstar', 'TheDevil');
        usr = HOG_TestDataFactory.assignPermissionSet(usr, 'HOG_FM_Dispatcher_Vendor');

        System.runAs(usr) {
            Test.startTest();                                
            ApexPages.currentPage().getParameters().put('id', oldTruckTripId); //urcenie hodnoty parametra
            ApexPages.StandardController stdCtrl = new ApexPages.StandardController(new FM_Truck_Trip__c()); //inicializacia
            FM_TruckTripRenewConfirmCtrl controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl); //volanie konstruktora bez parametra

            Facility__c facilityConfirm = [SELECT Id
                                            FROM Facility__c 
                                            LIMIT 1];

            Carrier_Unit__c unitConfirm = [SELECT Id
                                            FROM Carrier_Unit__c
                                            LIMIT 1];

            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM; 

            controller.handleModeChange();
            controller.truckTrip.Truck_Trip_Status__c = FM_TruckTrip_Utilities.STATUS_DISPATCHED;
            controller.loadConfirmation.Ticket_Number__c = 'Test1234';
            controller.loadConfirmation.Volume__c = 30;
            controller.truckTrip.Unit__c = unitConfirm.Id;
            controller.loadConfirmation.Destination_Facility__c = facilityConfirm.Id;
            controller.loadConfirmation.Scale_Ticket_Number__c = 'Test4321';
            controller.truckTrip.Truck_Trip_Status__c = FM_TruckTrip_Utilities.STATUS_DISPATCHED;
            Id oldCarrierUnit = [SELECT Id
                                    FROM Carrier_Unit__c][0].Id;
            Id newCarrierUnit = [SELECT Id
                                    FROM Carrier_Unit__c][1].Id;

            Id newTowingCompany = [SELECT Id
                                    FROM Towing_Company__c][0].Id;
            controller.isStuckTruck = true;      
            controller.stuckTruck.Carrier_Unit__c = newCarrierUnit; 
            controller.confirm();
            System.assertNotEquals(null, controller.stuckTruck.Stuck_From__c);
            System.assertNotEquals(null, controller.stuckTruck.Stuck_To__c);
            System.assertEquals(controller.stuckTruck.Status__c, FM_LoadConfirmation_Utilities.STUCK_TRUCK_STATUS_EXTERNAL_DEFAULT);
            System.assert(!ApexPages.hasMessages());
            Test.stopTest();
        }
    }

    @IsTest static void testScaleTicketNumberValidation() {
        id oldTruckTripId = [SELECT Id
        FROM FM_Truck_Trip__c
        WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED
        AND Shift_Day__c = 'Today'][0].Id;
        User usr = HOG_TestDataFactory.createUser('Tony', 'Stark', 'IronMan');
        usr = HOG_TestDataFactory.assignPermissionSet(usr, 'HOG_FM_Dispatcher');

        System.runAs(usr) {

            ApexPages.currentPage().getParameters().put('id', oldTruckTripId); //urcenie hodnoty parametra
            ApexPages.StandardController stdCtrl = new ApexPages.StandardController(new FM_Truck_Trip__c()); //inicializacia
            FM_TruckTripRenewConfirmCtrl controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl); //volanie konstruktora bez parametra

            Id facilityId = [SELECT Id FROM Facility__c LIMIT 1][0].Id;
            Id facilityId2 = [SELECT Id FROM Facility__c WHERE Id != :facilityId LIMIT 1][0].Id;
            Id locationId = [SELECT Id FROM Location__c LIMIT 1][0].Id;
            List<FM_Truck_Trip__c> tts = [SELECT Id FROM FM_Truck_Trip__c WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED];
            System.assert(facilityId != null);
            System.assert(facilityId2 != null);
            System.assert(locationId != null);
            System.assert(tts != null && tts.size() > 1);

            Test.startTest();
            //test set location
            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM;
            controller.isTruckTripConfirmable = true;
            //test set facility
            controller.handleModeChange();
            controller.loadConfirmation.Truck_Trip__c = tts.get(0).Id;
            controller.loadConfirmation.Destination_Facility__c = null;
            controller.loadConfirmation.Destination_Location__c = locationId;
            controller.loadConfirmation.Ticket_Number__c = 'test3';
            controller.loadConfirmation.Volume__c = 30;
            controller.loadConfirmation.Scale_Ticket_Number__c = 'test1';
            controller.confirm();
            System.assert(!ApexPages.hasMessages());

            controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl);
            //test set facilty (duplicate ticket for selected facility)
            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM;
            controller.isTruckTripConfirmable = true;
            controller.handleModeChange();
            controller.loadConfirmation.Truck_Trip__c = tts.get(1).Id;
            controller.loadConfirmation.Destination_Facility__c = null;
            controller.loadConfirmation.Destination_Location__c = locationId;
            controller.loadConfirmation.Ticket_Number__c = 'test4';
            controller.loadConfirmation.Volume__c = 30;
            controller.loadConfirmation.Scale_Ticket_Number__c = 'test1';
            controller.confirm();
            System.assert(ApexPages.hasMessages());
            System.assertEquals(1, ApexPages.getMessages().size());

            //test set facilty (duplicate ticket but other facility (no validation error))
            controller.loadConfirmation.Destination_Facility__c = facilityId2;
            controller.loadConfirmation.Destination_Location__c = null;
            controller.loadConfirmation.Ticket_Number__c = 'test4';
            controller.loadConfirmation.Volume__c = 30;
            controller.loadConfirmation.Scale_Ticket_Number__c = 'test1';
            controller.confirm();


            Test.stopTest();
        }
    }

    @IsTest static void testScaleTicketNumberValidationWithSecondAttempt() {
        id oldTruckTripId = [SELECT Id
        FROM FM_Truck_Trip__c
        WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED
        AND Shift_Day__c = 'Today'][0].Id;
        User usr = HOG_TestDataFactory.createUser('Tony', 'Stark', 'IronMan');
        usr = HOG_TestDataFactory.assignPermissionSet(usr, 'HOG_FM_Dispatcher');

        System.runAs(usr) {

            ApexPages.currentPage().getParameters().put('id', oldTruckTripId); //urcenie hodnoty parametra
            ApexPages.StandardController stdCtrl = new ApexPages.StandardController(new FM_Truck_Trip__c()); //inicializacia
            FM_TruckTripRenewConfirmCtrl controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl); //volanie konstruktora bez parametra

            Id facilityId = [SELECT Id FROM Facility__c LIMIT 1][0].Id;
            Id facilityId2 = [SELECT Id FROM Facility__c WHERE Id != :facilityId LIMIT 1][0].Id;
            Id locationId = [SELECT Id FROM Location__c LIMIT 1][0].Id;
            List<FM_Truck_Trip__c> tts = [SELECT Id FROM FM_Truck_Trip__c WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED];
            System.assert(facilityId != null);
            System.assert(facilityId2 != null);
            System.assert(locationId != null);
            System.assert(tts != null && tts.size() > 1);

            Test.startTest();
            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM;
            controller.isTruckTripConfirmable = true;
            controller.handleModeChange();
            controller.loadConfirmation.Truck_Trip__c = tts.get(0).Id;
            controller.loadConfirmation.Destination_Facility__c = facilityId;
            controller.loadConfirmation.Destination_Location__c = null;
            controller.loadConfirmation.Ticket_Number__c = 'test3';
            controller.loadConfirmation.Volume__c = 30;
            controller.loadConfirmation.Scale_Ticket_Number__c = 'test1';
            controller.confirm();
            System.assert(!ApexPages.hasMessages());
            Integer confirmationInitCount = [SELECT COUNT() FROM FM_Load_Confirmation__c];

            controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl);
            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM;
            controller.isTruckTripConfirmable = true;
            controller.handleModeChange();
            controller.loadConfirmation.Truck_Trip__c = tts.get(1).Id;
            controller.loadConfirmation.Destination_Facility__c = facilityId;
            controller.loadConfirmation.Destination_Location__c = null;
            controller.loadConfirmation.Ticket_Number__c = 'test4';
            controller.loadConfirmation.Volume__c = 30;
            controller.loadConfirmation.Scale_Ticket_Number__c = 'test1';
            controller.confirm();
            System.assert(ApexPages.hasMessages());
            System.debug(ApexPages.getMessages());
            Integer confirmationFirstAttemptCount = [SELECT COUNT() FROM FM_Load_Confirmation__c];

            controller.confirm(); //second attempt
            System.debug(ApexPages.getMessages());
            Integer confirmationSecondAttemptCount = [SELECT COUNT() FROM FM_Load_Confirmation__c];
            Test.stopTest();

            System.assertEquals(confirmationInitCount, confirmationFirstAttemptCount);
            System.assertNotEquals(confirmationFirstAttemptCount, confirmationSecondAttemptCount);
            System.assertEquals(confirmationFirstAttemptCount + 1, confirmationSecondAttemptCount);
        }
    }

    @IsTest static void testDuplicateConfirmationValidation() {
        id oldTruckTripId = [SELECT Id
        FROM FM_Truck_Trip__c
        WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED
        AND Shift_Day__c = 'Today'][0].Id;
        User usr = HOG_TestDataFactory.createUser('Tony', 'Stark', 'IronMan');
        usr = HOG_TestDataFactory.assignPermissionSet(usr, 'HOG_FM_Dispatcher');

        System.runAs(usr) {

            ApexPages.currentPage().getParameters().put('id', oldTruckTripId); //urcenie hodnoty parametra
            ApexPages.StandardController stdCtrl = new ApexPages.StandardController(new FM_Truck_Trip__c()); //inicializacia
            FM_TruckTripRenewConfirmCtrl controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl); //volanie konstruktora bez parametra

            List<FM_Truck_Trip__c> tts = [SELECT Id FROM FM_Truck_Trip__c WHERE Truck_Trip_Status__c =: FM_Utilities.TRUCKTRIP_STATUS_CANCELLED];

            Id facilityId = [SELECT Id FROM Facility__c LIMIT 1][0].Id;

            Test.startTest();
            //test set location
            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM;
            controller.isTruckTripConfirmable = true;
            controller.handleModeChange();
            controller.loadConfirmation.Truck_Trip__c = tts.get(0).Id;
            controller.loadConfirmation.Destination_Facility__c = facilityId;
            controller.loadConfirmation.Ticket_Number__c = 'test2';
            controller.loadConfirmation.Volume__c = 30;
            controller.confirm();
            System.assert(!ApexPages.hasMessages());

            controller = new FM_TruckTripRenewConfirmCtrl(stdCtrl);
            //test duplicate confirmation on same TT
            controller.selectedMode = FM_TruckTrip_Utilities.UNCANCEL_MODE_CONFIRM;
            controller.isTruckTripConfirmable = true;
            controller.handleModeChange();
            controller.loadConfirmation.Truck_Trip__c = tts.get(0).Id;
            controller.loadConfirmation.Destination_Facility__c = facilityId;
            controller.loadConfirmation.Ticket_Number__c = 'test3';
            controller.loadConfirmation.Volume__c = 30;
            controller.loadConfirmation.Scale_Ticket_Number__c = 'test3';
            controller.confirm();
            System.assert(ApexPages.hasMessages());
            System.assertEquals(1, ApexPages.getMessages().size());

            Test.stopTest();
        }
    }

   	@testSetup
    static void setData() {
        Account acc = (Account) HOG_SObjectFactory.createSObject(new Account(), true);

        Field__c field = HOG_TestDataFactory.createAMU(true);

        Carrier__c carrier = FM_TestDataFactory.createCarrier(acc.Id, true);
        Carrier_Unit__c unit = FM_TestDataFactory.createCarrierUnit(carrier.Id, true);
        Carrier_Unit__c unit2 = FM_TestDataFactory.createCarrierUnit('BMW 330DX E91', carrier.Id, true); 
        Towing_Company__c towingCompany = FM_TestDataFactory.createTowingCompany('Big Bad Boy', true);

        Route__c route = HOG_TestDataFactory.createRoute(true);

        Location__c location = HOG_TestDataFactory.createLocation(route.Id, field.Id, true);
        Location__c location2 = HOG_TestDataFactory.createLocation('Location2', route.Id, field.id, true);

        Equipment_Tank__c equipmentTank = HOG_TestDataFactory.createEquipmentTank(location, true);

        Facility__c facility = HOG_TestDataFactory.createFacility(route.Id, field.Id, true);
        Facility__c facility2 = HOG_TestDataFactory.createFacility('Facility2', route.Id, field.Id, true);

        Equipment_Tank__c eqt2 = HOG_TestDataFactory.createEquipmentTank(location2, true);


        List<FM_Load_Request__c> loadRequestList = new List<FM_Load_Request__c>();
        loadRequestList.add(FM_TestDataFactory.createLoadRequestOnLocation(carrier.Id, null,
                                                                        facility.Id,
                                                                        'O', null,
                                                                        'Night',
                                                                        location.Id,
                                                                        FM_LoadRequest_Utilities.LOADREQUEST_STATUS_DISPATCHED,
                                                                        false));

        loadRequestList.add(FM_TestDataFactory.createLoadRequestOnLocation(carrier.Id,  null, 
                                                                        facility.Id,
                                                                        'W', null, 
                                                                        'Night', 
                                                                        location.Id, 
                                                                        FM_LoadRequest_Utilities.LOADREQUEST_STATUS_NEW, 
                                                                        false)); 

        loadRequestList.add(FM_TestDataFactory.createLoadRequestOnLocation(carrier.Id, null, 
                                                                        facility.Id,
                                                                        'O', null, 
                                                                        'Day', 
                                                                        location.Id, 
                                                                        FM_LoadRequest_Utilities.LOADREQUEST_STATUS_DISPATCHED, 
                                                                        false)); 

        insert loadRequestList;

        List<FM_Truck_Trip__c> truckTrips = new List<FM_Truck_Trip__c>();
        truckTrips.add(FM_TestDataFactory.createTruckTrip(loadRequestList.get(0), 
	                                                    'Today', 
	                                                    FM_Utilities.TRUCKTRIP_STATUS_DISPATCHED, 
	                                                    unit.Id, 
	                                                    false));

        truckTrips.add(FM_TestDataFactory.createTruckTrip(loadRequestList.get(1), 
	                                                    'Tomorrow', 
	                                                    FM_Utilities.TRUCKTRIP_STATUS_NEW, 
	                                                    unit.Id, 
	                                                    false));

        truckTrips.add(FM_TestDataFactory.createTruckTrip(loadRequestList.get(2), 
	                                                    'Today', 
	                                                    FM_Utilities.TRUCKTRIP_STATUS_DISPATCHED, 
	                                                    unit.Id, 
	                                                    false));
        insert truckTrips;

        truckTrips.get(0).Truck_Trip_Status__c = FM_Utilities.TRUCKTRIP_STATUS_CANCELLED;
        truckTrips.get(0).Load_Request_Cancel_Reason__c = HOG_GeneralUtilities.getDefaultOrFirstForPicklist(FM_Load_Request__c.Cancel_Reason__c.getDescribe().getSObjectField());
        truckTrips.get(1).Truck_Trip_Status__c = FM_Utilities.TRUCKTRIP_STATUS_CANCELLED;
        truckTrips.get(1).Load_Request_Cancel_Reason__c = HOG_GeneralUtilities.getDefaultOrFirstForPicklist(FM_Load_Request__c.Cancel_Reason__c.getDescribe().getSObjectField());

        update truckTrips;
    }
}



/*

line:               what:
70                  modeTitle _/
145                 getUnitChanged _/
165                 getStuckTruckUnitNoteText_/
158                 getOldTruckTripLabel
175                 getTruckTrip
182                 getHistoryDataForTruckTrip
191                 getLoadConfirmationOnFacilityWithScaleTicketNumber
204                 getConfirmationOnTT
217                 ????
---250              ????
253                 PageReference
--- 296             po renew
311                 isValidTruckTrip
330                 isRenewDataValid
339                 isConfirmDataValid
352                 isNewTruckTripValid
363                 isLoadConfirmationValid
380                 isStuckTruckValid
392                 isStuckTruckCarrierValid
401                 isStuckFromValid
413                 isStuckToValid
425                 isTowingCompanyValid
438                 isValidTicketNumber
447                 isValidVolume
457                 isValidDestination
473                 isValidUnitChangeReason
484                 hasUnitChangeReason
493                 hasNoUnitChangeReason
503                 hasOtherUnitChangeReason
512                 isOtherUnitChangeReason
526                 isValidScaleTicket
539                 isValidScaleTicketOnLocation
552                 isValidScaleTicketOnFacility
562 -- 616          ????
629                 tryToSaveTruckTripsAndLoadRequest
656                 tryToSaveLoadConfirmationAndStuckTruck
724                 doInitialInsertForStuckTruck
738                 PageReference
740 -- end          ????

*/